import javabook.*;
    
/**
 * Write a description of class InformationManager here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class InformationManager
{
    MainWindow mw;
    InputBox iBox;
    OutputBox oBox;
    ListBox mainOptions, studentOptions, courseOptions;
    
    private Student [] student;
    private int studentSlotNumber = 0;    
    
    private Course  [] course;
    private int courseSlotNumber = 0;
    
    public InformationManager() {
      mw = new MainWindow();
      iBox = new InputBox(mw);
      oBox = new OutputBox(mw);
      
      mainOptions = new ListBox(mw, "Select a main option");
      mainOptions.addItem("Manage Student Records");
      mainOptions.addItem("Manage Course Records");
      mainOptions.addItem("Exit System");
      
      studentOptions = new ListBox(mw, "Select a student option");
      studentOptions.addItem("Create new student");
      studentOptions.addItem("List all students");
      studentOptions.addItem("Enroll student in course");
      studentOptions.addItem("Return to main menu");
      
      student = new Student[10];
      
      courseOptions = new ListBox(mw, "Select a course option");
      courseOptions.addItem("Create new course");
      courseOptions.addItem("List all available courses");
      courseOptions.addItem("Enroll a student in course");
      courseOptions.addItem("Return to main menu");
      
      course = new Course[10];
    }
    
    public void start() {
       mw.setVisible(true);
       
       
       int option = -1;
       while ( option != 2) {
       option = mainOptions.getSelectedIndex();
       
     
       if ( option == 0 )
          manageStudents();
       else if ( option == 1 )
          manageCourses();
       else if (option == 2) 
          System.exit(0);
       } 
     
    }
    
    private void manageStudents() {
    
      int option = studentOptions.getSelectedIndex();

      switch ( option ) {
       case 0:
         createStudent();
         break;
       case 1:
         listStudents();
         break;
       case  2:
          addCourse();
          break;
      }
      
      return;
    }
    private void createStudent() {

      String sid = iBox.getString("Enter Student id: ");
      String name = iBox.getString("Enter Student name: ");
      student[studentSlotNumber] = new Student(sid,name);

      studentSlotNumber++;
      oBox.setVisible(true);
      oBox.printLine("Created student "+name+" with id "+sid);
      oBox.waitUntilClose();
    }
    private void listStudents() {
      oBox.setVisible(true);
      for(int i=0; i < studentSlotNumber; i++) 
         oBox.printLine(student[i].getSSN()+"\t"+student[i].getName());
         oBox.waitUntilClose();
    }
    private void addCourse() {
       //theStudent.add(theCourse);
    }
    
    
    private void manageCourses() {
    int option = courseOptions.getSelectedIndex();

      switch ( option ) {
       case 0:
         createCourse();
         break;
       case 1:
         listCourses();
         break;
       case  2:
          enrollStudent();
          break;
      }
      
      return;
    }
    
    private void createCourse() {

      String courseName = iBox.getString("Enter course name: ");
      String courseTitle = iBox.getString("Enter credit title: ");
      course[courseSlotNumber] = new Course(courseName, courseTitle);

      courseSlotNumber++;
      oBox.setVisible(true);
      oBox.printLine("Created course "+courseName+" with id "+courseTitle);
      oBox.waitUntilClose();
    }
    
    private void listCourses() {
      oBox.setVisible(true);
      for(int i=0; i < courseSlotNumber; i++) 
         oBox.printLine(course[i].getName()+"\t"+course[i].getTitle());
         oBox.waitUntilClose();
    }
    
    private void enrollStudent() {
    
      ListBox studentList = generateStudentList();
    
      ListBox courseList = generateCourseList();
    
      String studentName = studentList.getSelectedItem();
    
      String courseName = courseList.getSelectedItem();

      oBox.printLine("Enrolling "+studentName+" in "+ courseName);
    
      Student s = findStudentObject(studentName);
    
      Course c = findCourseObject(courseName);

      c.enroll(s);
    }
    
    private ListBox generateStudentList() {
      
      ListBox studentList = new ListBox(mw, "Pick a student to enroll");
      
      for(int i=0; i < studentSlotNumber; i++)
        studentList.addItem(student[i].getName());
        
      return studentList;
    }
    
    private ListBox generateCourseList() {
      
      ListBox courseList = new ListBox(mw, "Pick a course");
      
      for(int i=0; i < courseSlotNumber; i++)
        courseList.addItem(course[i].getName());
        
      return courseList;
    }
    
   private Student findStudentObject(String name) {
    
    for(int i=0; i < studentSlotNumber; i++) {
        String thisName = student[i].getName();
        if ( thisName.equals(name) )
            return student[i];
    }

    return null;
  }

  private Course findCourseObject(String name) {
    
    for(int i=0; i < courseSlotNumber; i++) {
        String thisName = course[i].getName();
        if ( thisName.equals(name) )
            return course[i];
    }

    return null;
  }
    
      
}
